/*****************************************************************************
 *
 * Copyright (C) 2002 Polytechnic University of Valencia.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors: Carlos Calafate, <calafate@disca.upv.es>
 *
 *****************************************************************************/

#ifndef _PACKET_H
#define _PACKET_H

#include <sys/socket.h> // for struct sockaddr
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <asm/types.h>
#include <asm/ioctl.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <linux/socket.h>
#include <linux/if.h>
#include <linux/if_ether.h>
#include <linux/if_packet.h>

#include "PICAspec.h"


#define PICA_SEND 0
#define PICA_RECEIVE 1

#define PROMISCUOUS 0

typedef int PICA_IO_DEVICE; 

int PICAopenDevice(char * device, PICA_IO_DEVICE * iodev, int timeout, int mode);
int PICAframe(int mode, PICA_IO_DEVICE iodev, void * packet, int packetsize, int * read);
int PICAcloseDevice(PICA_IO_DEVICE iodev);
int PICAcreatePacket(char *addr, unsigned char *data, int datasize, unsigned char * packet, int * packetsize);

#endif
