

#include "sock.h"



int PICAcreateSocket(PICAsocket * sd, int domain, int type, int protocol, int block) {

	unsigned long non_block=1;
	
	if (sd == NULL) {
		P_ERROR("PICAcreateSocket: socket pointer is NULL", 50101);
		return 0;
	}

       
	if ((*sd = socket(domain, type, protocol)) == INVALID_SOCKET) {
		P_ERROR("PICAcreateSocket: Unable to create socket", 50102);
		return 0;
	}

	if(block==NO_BLOCK)
	{
		if (ioctlsocket(*sd,FIONBIO,&non_block) != 0) {
			P_ERROR("PICAcreateSocket: Unable to set socket blokking", 50103);
			return 0;
		}

	}
  
	return 1;
}


int PICAcloseSocket(PICAsocket sd) {

	if (closesocket(sd) != 0) {
		P_ERROR("PICAcreateSocket: Error closing socket", 50201);
		return 0;
	}
	return 1;
}
